#
# Don't change this file. It was autogenerated by make
#
%define my_version 1.3.1
%define my_release 1

Name:          statifier
Version:       %{my_version}
Release:       %{my_release}
License:       GPL
Group:         Development/Tools
Summary:       Convert elf dynamic linked exe to "pseudo-static"
Packager:      Valery Reznic <valery_reznic@users.sourceforge.net>
Source:	       %{name}-%{version}.tar.gz
Url:           http://%{name}.sourceforge.net	
ExclusiveOs:   Linux
ExclusiveArch: %{ix86}
ExclusiveArch: x86_64
Requires:      binutils
Requires:      gawk
Requires:      gdb >= 5.2
BuildRoot:     %{_builddir}/%{buildsubdir}-install-root

%ifarch %{ix86}
   %define has_elf_32 1
   %define has_elf_64 0
%endif

%ifarch x86_64
   %define has_elf_32 1
   %define has_elf_64 1
%endif

%description
Statifier create from dynamically linked ELF executable
and all it's libraries (and all LD_PRELOAD libraries if any)
one file. This file can be copied and run on another machine
without need to drag all it's libraries.

%prep
%setup

%build
make all

%install
if [ "$RPM_BUILD_ROOT" != "/" ]; then
   rm -rf "$RPM_BUILD_ROOT"
else
   :
fi
make install DESTDIR="$RPM_BUILD_ROOT" MANPAGE_SUFFIX=.gz

%clean
if [ "$RPM_BUILD_ROOT" != "/" ]; then
   rm -rf "$RPM_BUILD_ROOT"
else
   :
fi

%files



%defattr(-,root,root)

%dir /usr/lib/statifier
     /usr/lib/statifier/VERSION
     /usr/lib/statifier/statifier.sh
     /usr/lib/statifier/statifier_lib.src
     /usr/lib/statifier/statifier_parser.src
     /usr/lib/statifier/statifier_common.sh
     /usr/lib/statifier/statifier_before_dump.sh
     /usr/lib/statifier/statifier_dump.sh
     /usr/lib/statifier/statifier_before_starter.sh
     /usr/lib/statifier/statifier_create_starter.sh
     /usr/lib/statifier/statifier_create_exe.sh
     /usr/lib/statifier/dumps.sh
     /usr/lib/statifier/regs.sh
     /usr/lib/statifier/set_thread_area.sh
     /usr/lib/statifier/split.sh
     /usr/lib/statifier/dumps.gdb
     /usr/lib/statifier/first.gdb
     /usr/lib/statifier/map_reg_core.gdb

     /usr/bin/statifier

%doc %{_mandir}/man1/statifier.1*

%doc AUTHORS
%doc ChangeLog
%doc FAQ
%doc INSTALL
%doc LICENSE
%doc NEWS
%doc README
%doc THANKS
%doc TODO

%doc doc
%if %{has_elf_32}
%dir /usr/lib/statifier/32
     /usr/lib/statifier/32/dl-var
     /usr/lib/statifier/32/elfinfo
     /usr/lib/statifier/32/loader_base_test
     /usr/lib/statifier/32/phdrs
     /usr/lib/statifier/32/regs
     /usr/lib/statifier/32/set_thread_area_addr
     /usr/lib/statifier/32/set_thread_area
     /usr/lib/statifier/32/strtoul
     /usr/lib/statifier/32/tls_test
     /usr/lib/statifier/32/statifier_lib.src
     /usr/lib/statifier/32/statifier_common.sh
     /usr/lib/statifier/32/statifier_before_dump.sh
     /usr/lib/statifier/32/statifier_dump.sh
     /usr/lib/statifier/32/statifier_before_starter.sh
     /usr/lib/statifier/32/statifier_create_starter.sh
     /usr/lib/statifier/32/statifier_create_exe.sh
     /usr/lib/statifier/32/dumps.sh
     /usr/lib/statifier/32/regs.awk
     /usr/lib/statifier/32/regs.sh
     /usr/lib/statifier/32/set_thread_area.sh
     /usr/lib/statifier/32/split.sh
     /usr/lib/statifier/32/dumps.gdb
     /usr/lib/statifier/32/first.gdb
     /usr/lib/statifier/32/map_reg_core.gdb
     /usr/lib/statifier/32/set_thread_area.gdb
%endif
%if %{has_elf_64}
%dir /usr/lib/statifier/64
     /usr/lib/statifier/64/dl-var
     /usr/lib/statifier/64/elfinfo
     /usr/lib/statifier/64/loader_base_test
     /usr/lib/statifier/64/phdrs
     /usr/lib/statifier/64/regs
     /usr/lib/statifier/64/set_thread_area_addr
     /usr/lib/statifier/64/set_thread_area
     /usr/lib/statifier/64/strtoul
     /usr/lib/statifier/64/tls_test
     /usr/lib/statifier/64/statifier_lib.src
     /usr/lib/statifier/64/statifier_common.sh
     /usr/lib/statifier/64/statifier_before_dump.sh
     /usr/lib/statifier/64/statifier_dump.sh
     /usr/lib/statifier/64/statifier_before_starter.sh
     /usr/lib/statifier/64/statifier_create_starter.sh
     /usr/lib/statifier/64/statifier_create_exe.sh
     /usr/lib/statifier/64/dumps.sh
     /usr/lib/statifier/64/regs.awk
     /usr/lib/statifier/64/regs.sh
     /usr/lib/statifier/64/set_thread_area.sh
     /usr/lib/statifier/64/split.sh
     /usr/lib/statifier/64/dumps.gdb
     /usr/lib/statifier/64/first.gdb
     /usr/lib/statifier/64/map_reg_core.gdb
     /usr/lib/statifier/64/set_thread_area.gdb
%endif

%changelog
* Mon May 31 2004 <valery_reznic@users.sourceforge.net> 1.3.1-1
- processor.h was split to cpus/*/processor.h
- elf2at.make.sh was removed
- added documentation directory doc and documentation itself.
- added FAQ file

* Sun May  9 2004 <valery_reznic@users.sourceforge.net> 1.3.1-1
- cpus/x86_64/dl-var.S were converted to use dl-var.c and dl-var.inc
- added flag -mregparm=0 to be sure parameters passed via stack

* Wed May  5 2004 <valery_reznic@users.sourceforge.net> 1.3.1-1
- cpus/i386/dl-var.S were converted to use dl-var.c and dl-var.inc
- Makefile was adopted to this changes

* Tue May  4 2004 <valery_reznic@users.sourceforge.net> 1.3.0-1
- statifier_common.sh, CheckTls - grep was changed to awk

* Mon May  3 2004 <valery_reznic@users.sourceforge.net> 1.3.0-1
- added options --verbose and --keep-working-directory
- src/regs.sh now not use GNU awk extension.
- src/regs.awk was added.

* Sun May  2 2004 <valery_reznic@users.sourceforge.net> 1.3.0-1
- added options --versions and --help

* Thu Apr 29 2004 <valery_reznic@users.sourceforge.net> 1.3.0-1
- added file statifier_parser.src - parsing options.
- added Echo function to the statifier_lib.src
- updated man page

* Wed Apr 28 2004 <valery_reznic@users.sourceforge.net> 1.3.0-1
- changes in phdrs.c - relax check in order to work with
  linux >= 2.5 and gdb 6.1
- statifier_common.sh - more correct handling of BaseAddr and VirtAddr.
- map_reg_core.gdb was simplified - any way now i have absolute
  address of _dl_start_user and need no gdb's help to find it.
- get rid of gdb's (>= 6.0) message: rtld.c: No such file or directory
- statifier.sh if executable have no absolute path prepend ./ to it name
  (it prevent gdb from ocassionly pickup executable from another place)

* Sun Apr 25 2004 <valery_reznic@users.sourceforge.net> 1.2.1-1
- massive changes: statifier.sh split to lot of statifier_*.sh
- add statifier_lib.src
- add loader_base_test.c
- dl_ vars format was changed: now it's not offset from DL_BASE, 
  but absolute value. */dl-var.S were changed.
- readlink not used.  Makefile and rpm/files adjusted. 

* Thu Apr 22 2004 <valery_reznic@users.sourceforge.net> 1.2.1-1
- phdrs.c accept one more arguments - 'ignored_segments' 
- statifier.sh CreateExeFile now calculate and use IGNORED_SEGMENTS
- elfinfo.c program was added.

* Mon Apr 19 2004 <valery_reznic@users.sourceforge.net> 1.2.0-1
- examples added to the man

* Sun Apr 18 2004 <valery_reznic@users.sourceforge.net> 1.2.0-1
- now both elf32 and elf64 executables are supported.
- added support for amd64 (x86_64) processor

* Wed Apr  7 2004 <valery_reznic@users.sourceforge.net> 1.1.1-1
- reworked tls detection. added tls_test program
- add readlink program
- add dl-var
- set some loader variables as they should be
- fixed segfault in statified exe, which use dlsym function and dlsym
  can't find symbol. (May by it fix other segfaults too)

* Mon Mar 30 2004 <valery_reznic@users.sourceforge.net> 1.1.1-1
- fixed bug in the statifier.sh - added path to the set_thread_area_addr
- set_thread_area_addr program if it somehow miss syscall 
  'set_thread_area' exit with status 1, instead of status of
  inspected program.
- set_thread_area_addr.c - added function safe_fd - in case
  i miss 'set_thread_area' syscall

* Wed Mar 24 2004 <valery_reznic@users.sourceforge.net> 1.1.0-1
- a lot of change in order to support TLS (thread local storage)

* Mon Mar 16 2004 <valery_reznic@users.sourceforge.net> 1.1.0-1
- Fixed bug with Interpreter detection for (at least) LANG=es_ES@euro

* Mon Mar 15 2004 <valery_reznic@users.sourceforge.net> 1.0.0-1
- First public release
